﻿// dllmain.cpp : DLL アプリケーションのエントリ ポイントを定義します。
#include "pch.h"
#include "atsplugin.h"
#include "TASC.h"
#include "dllmain.h"

BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
                     )
{
    switch (ul_reason_for_call)
    {
    case DLL_PROCESS_ATTACH:
    case DLL_THREAD_ATTACH:
    case DLL_THREAD_DETACH:
    case DLL_PROCESS_DETACH:
        break;
    }	



	//iniファイル用パス取得
	GetModuleFileName(
		(HINSTANCE)hModule,    // モジュールのハンドル
		fullpath,  // モジュールのファイル名
		sizeof(fullpath)        // バッファのサイズ
	);

	//TASC設定ファイル用パス取得
	GetModuleFileName(
		(HINSTANCE)hModule,    // モジュールのハンドル
		g_tasc.fullpath,  // モジュールのファイル名
		sizeof(g_tasc.fullpath)        // バッファのサイズ
	);


	//dllフルパスをiniファイル用パスに変換
	_splitpath_s(fullpath, drive, sizeof(drive), dir, sizeof(dir), NULL, NULL, NULL, NULL);
	ua_tcscpy_s(inipath, drive);
	strcat_s(inipath, dir);
	strcat_s(inipath, "TASC.ini");
	
	//ポインタ設定
	g_tasc.deltaT = &g_deltaT;
	g_tasc.Vstate = &g_state;
	g_tasc.Handles = &g_handle;

    return TRUE;
}


ATS_API void WINAPI Load()
{

}

ATS_API void WINAPI Dispose()
{

}

ATS_API int WINAPI GetPluginVersion()
{
	return ATS_VERSION;
}

ATS_API void WINAPI SetVehicleSpec(ATS_VEHICLESPEC vehicleSpec)
{
	g_svcBrake = vehicleSpec.BrakeNotches;
	g_emgBrake = g_svcBrake + 1;
}


ATS_API void WINAPI Initialize(int brake)
{

	g_deltaT = 0;//フレーム時間
	g_handle.Power = 0;//力行
	g_handle.Brake = g_svcBrake;//ブレーキ
	g_handle.Reverser = 1;//レバーサ
	g_handle.ConstantSpeed = ATS_CONSTANTSPEED_DISABLE;//定速


	char tascP1_dec[8]; //B7減速度
	char tascRtime[8]; //B7減速度

	//B7減速度取得
	GetPrivateProfileString("TASCPtn", "B7Dec", "3.36", tascP1_dec, sizeof(tascP1_dec), inipath);
	//編成コード設定取得
	g_tasc.Formation = GetPrivateProfileInt("TASCPtn", "FormationID", 1, inipath);
	//空走時間取得
	GetPrivateProfileString("TASCPtn", "RTime", "0.00", tascRtime, sizeof(tascRtime), inipath);

	//停車パターン連動設定取得
	g_tasc.enableHmPtn = GetPrivateProfileInt("HmPtn", "EnableHmPtn", 0, inipath);


	//文字列で取得したB7減速度データをfloatに変換して代入
	g_tasc.basedec = atof(tascP1_dec);
	g_tasc.RTime = atof(tascRtime);

	//TASC初期化
	g_tasc.init();
}


ATS_API ATS_HANDLES WINAPI Elapse(ATS_VEHICLESTATE vehicleState, int* panel, int* sound)
{
	//処理
	g_deltaT = max(vehicleState.Time - g_state.Time, 0);
	g_state = vehicleState;

	//TASC処理
	g_tasc.Main();

	//レバーサ
	g_output.Reverser = g_handle.Reverser;

	//力行
	g_output.Power = g_handle.Power;

	//力行カット条件
	//(インチング制御以外かつTASCブレーキ動作)or(インチング制御中かつ1.8km/h以上)
	if ((!g_tasc.inching && g_tasc.TASCBr >= 0)||
		g_tasc.inching && g_state.Speed > 1.8)
		g_output.Power = 0;


	//定速
	g_output.ConstantSpeed = ATS_CONSTANTSPEED_CONTINUE;

	//ブレーキ
	g_output.Brake = g_handle.Brake;

	//TASCブレーキ>ハンドル位置の場合TASCのBノッチを出力
	if (g_handle.Brake * 4 < g_tasc.TASCBr)
	{
		g_output.ConstantSpeed = ATS_CONSTANTSPEED_DISABLE;

		//TASCブレーキ%4==0(補助ノッチ0)の場合はBノッチをそのまま出力
		if(g_tasc.TASCBr % 4 == 0)
			g_output.Brake = g_tasc.TASCBr / 4;
		//TASCブレーキ%4!=0(補助ノッチ0以外)の場合は11以上のノッチに応じた値を出力
		else
			g_output.Brake = 10 + (g_tasc.TASCBr % 4) + (g_tasc.TASCBr / 4 * 3);
	}







	// パネル出力
	panel[85] = g_tasc.TASCPwLp;//TASC電源
	panel[86] = g_tasc.TASCPtnLp;//TASCパターン
	panel[87] = g_tasc.TASCBrLp;//TASCブレーキ
	panel[88] = g_tasc.TASCCOLp;//TASC切
	panel[89] = g_tasc.IntCtrlLp;//インチング制御中

	// サウンド出力


	return g_output;
}

ATS_API void WINAPI SetPower(int notch)
{
	g_handle.Power = notch;

}

ATS_API void WINAPI SetBrake(int notch)
{
	g_handle.Brake = notch;

}

ATS_API void WINAPI SetReverser(int pos)
{
	g_handle.Reverser = pos;
}

ATS_API void WINAPI KeyDown(int atsKeyCode1)
{

}

ATS_API void WINAPI KeyUp(int atsKeyCode2)
{

}

ATS_API void WINAPI HornBlow(int atsHornBlowIndex)
{

}

ATS_API void WINAPI DoorOpen()
{

}

ATS_API void WINAPI DoorClose()
{

}

ATS_API void WINAPI SetSignal(int signal)
{

}

ATS_API void WINAPI SetBeaconData(ATS_BEACONDATA beaconData)
{
	switch (beaconData.Type)
	{
	case ATS_BEACON_TASCP1://P1
		if(g_state.Speed)g_tasc.PassedTASCP(1,beaconData.Optional);
		break;
	case ATS_BEACON_TASCP2://P2
		if (g_state.Speed)g_tasc.PassedTASCP(2, beaconData.Optional);
		break;
	case ATS_BEACON_TASCP3://P3
		if (g_state.Speed)g_tasc.PassedTASCP(3, beaconData.Optional);
		break;
	case ATS_BEACON_HmSet://停車パターンをセット
		g_tasc.HmR = min(3,max(beaconData.Optional,0));
		break;
	case ATS_BEACON_FDTP://P0地上子
		g_tasc.PassedP0();
		break;
	}
}